# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b5"
os.chdir("/Users/wstein/edu/2006-2007/bsd/sage_notebook/worksheets/admin/1/cells/1")
sage.server.notebook.interact.SAGE_CELL_ID=1
_sage_const_3 = Integer(3); _sage_const_2 = Integer(2); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_4 = Integer(4); _sage_const_100 = Integer(100); _sage_const_10 = Integer(10); _sage_const_1000 = Integer(1000)
def qflist(D, N, b):
    b = ZZ(b)
    R = ZZ((b**_sage_const_2  - D)/(_sage_const_4 *N))
    L = []
    Lprime = []
    for d in divisors(R):
       fqf = BinaryQF([d*N,b,R/d])
       fr = fqf.reduce()
       if not fr in Lprime:
           Lprime.append(fr)
           L.append(fqf)
    return L

def tau(f):
   A,B,C = f
   D = f.discriminant()
   return (-B + sqrt(D))/(_sage_const_2 *A)

def phi(E, k, z, prec):
    """
    Map a point z in the upper half plan to a point on the complex torus
    representation of the elliptic curve, using prec terms of the
    modular parametrization.
    """
    b = exp(_sage_const_2 *pi*I*z)
    q = k(b)
    a = E.anlist(prec)
    return sum( k(a[n]/n) * q**n for n in xrange(_sage_const_1 ,prec))

def topoint(E, k, z):
    """
    Given a point in the complex lattice representation of E, return
    a point on the Weierstrass model of E.
    """
    E2 = E.change_ring(k)
    gp.set_real_precision(k.prec()+_sage_const_10 )
    e = gp(E2)
    w = list(e.ellztopoint(z))
    k = E2.base_field()
    return E2.point([k(repr(w[_sage_const_0 ])), k(repr(w[_sage_const_1 ])), k(_sage_const_1 )], check=False)

def compute_y(E, FD, lam, prec_field=_sage_const_100 , prec_ser=_sage_const_1000 ):
    N = E.conductor()
    D = FD * lam**_sage_const_2
    srs = Mod(D, _sage_const_4 *N).sqrt(all=True)
    S = list(set([Mod(a, _sage_const_2 *N) for a in srs]))
    L = sum([qflist(D, N, b) for b in S], [])
    best = min([qf[_sage_const_1 ] for qf in L])
    for qf in L:
        if qf[_sage_const_1 ] == best:
           break
    z = tau(qf)
    print z
    k = ComplexField(prec_field)
    y_lattice_point = phi(E, k, z, prec_ser)
    y = topoint(E, k, y_lattice_point)
    return y

def Lambda1(E, ell, bnd):
    v = []
    p = _sage_const_3
    while len(v) < bnd:
        if valuation(gcd(p+_sage_const_1 , E.ap(p)), ell) >= _sage_const_1 :
            v.append(p)
        p = next_prime(p)
    return v

print "e5"
