from __future__ import with_statement
print "b242"
os.chdir("/home/was/edu/2007/bsd/sage_notebook/worksheets/heegner3_identify/cells/212")
ms = ModularSymbols
ec = EllipticCurve


#x = polygen(QQ,'x')

#auto
def qflist(D, N, b):
    b = ZZ(b)
    R = ZZ((b**Integer(2) - D)/(Integer(4)*N))
    L = []
    Lprime = []
    for d in divisors(R):
       fqf = BinaryQF([d*N,b,R/d])
       fr = fqf.reduce()
       if not fr in Lprime:
           Lprime.append(fr)
           L.append(fqf)
    return L

def tau(f):
   A,B,C = f
   D = f.discriminant()
   return (-B + sqrt(D))/(Integer(2)*A)

def phi(E, k, z, prec):
    """
    Map a point z in the upper half plan to a point on the complex torus
    representation of the elliptic curve, using prec terms of the
    modular parametrization.
    """
    b = exp(Integer(2)*pi*I*z)
    q = k(b)
    a = E.anlist(prec)
    return sum( k(a[n]/n) * q**n for n in xrange(Integer(1),prec))

def topoint(E, k, z):
    """
    Given a point in the complex lattice representation of E, return
    a point on the Weierstrass model of E.
    """
    E2 = E.change_ring(k)
    gp.set_real_precision(k.prec()/RealNumber('3.0')+Integer(10))
    e = gp(E2)
    w = list(e.ellztopoint(z))
    k = E2.base_field()
    return E2.point([k(repr(w[Integer(0)])), k(repr(w[Integer(1)])), k(Integer(1))], check=False)
print "\n\nv=%s"%_support_.variables(True)
print "e242"
